package de.dhbwloe.campusapp.search;

import android.util.Xml;

import com.loopj.android.http.AsyncHttpClient;
import com.loopj.android.http.AsyncHttpResponseHandler;

import org.jsoup.nodes.Document;

import java.io.ByteArrayInputStream;
import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;

import de.dhbwloe.campusapp.fragments.AppSearchListItem;
import de.dhbwloe.campusapp.network.XmlEntry;
import de.dhbwloe.campusapp.network.XmlRequestHelper;

/**
 * Created by pk910 on 25.01.2016.
 */
public class StuvSearchHelper extends SearchHelper {

    public StuvSearchHelper() {
        super(false);

    }

    @Override
    protected void processWebRequest(AsyncHttpResponseHandler handler, String keywords) {
        AsyncHttpClient client = new AsyncHttpClient();
        String url = null;
        try {
            url = "http://stuv-loerrach.de/feed/?s="+ URLEncoder.encode(keywords, "UTF-8");
        } catch (UnsupportedEncodingException e) {
        }
        client.get(url, null, handler);
    }

    @Override
    protected List<AppSearchListItem> onHtmlDocumentReceived(Document document) {
        //unused in here
        return null;
    }

    @Override
    protected List<AppSearchListItem> onPlainTextReceived(byte[] data) {
        ByteArrayInputStream inputStream = new ByteArrayInputStream(data);
        List<XmlEntry> entries = XmlRequestHelper.parseXml(inputStream, "channel", "item");
        ArrayList<AppSearchListItem> results = new ArrayList<>();

        for(XmlEntry entry : entries) {
            XmlEntry element;

            SearchTarget target = new SearchTarget();
            target.setInAppTarget(true);
            target.setTargetUrl("WebBrowser");

            element = XmlEntry.FindXmlEntryByName(entry, "title");
            String title = (element == null ? null : element.getValue());

            element = XmlEntry.FindXmlEntryByName(entry, "link");
            String link = (element == null ? null : element.getValue());

            element = XmlEntry.FindXmlEntryByName(entry, "description");
            String description = (element == null ? null : element.getValue());

            target.setArgument("url", link);

            AppSearchListItem result = new AppSearchListItem("STUV: "+title, description, target);
            results.add(result);

        }

        return results;
    }

}
