package de.dhbwloe.campusapp.wifi;

import android.app.DownloadManager;
import android.net.NetworkInfo;
import android.net.SSLCertificateSocketFactory;
import android.net.SSLSessionCache;
import android.net.wifi.WifiInfo;
import android.os.AsyncTask;
import android.util.Log;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.KeyManager;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManager;

import cz.msebera.android.httpclient.HttpVersion;
import cz.msebera.android.httpclient.NameValuePair;
import cz.msebera.android.httpclient.client.HttpClient;
import cz.msebera.android.httpclient.client.methods.HttpPost;
import cz.msebera.android.httpclient.conn.ClientConnectionManager;
import cz.msebera.android.httpclient.conn.scheme.PlainSocketFactory;
import cz.msebera.android.httpclient.conn.scheme.Scheme;
import cz.msebera.android.httpclient.conn.scheme.SchemeRegistry;
import cz.msebera.android.httpclient.impl.client.DefaultHttpClient;
import cz.msebera.android.httpclient.impl.conn.tsccm.ThreadSafeClientConnManager;
import cz.msebera.android.httpclient.message.BasicNameValuePair;
import cz.msebera.android.httpclient.params.BasicHttpParams;
import cz.msebera.android.httpclient.params.HttpParams;
import cz.msebera.android.httpclient.params.HttpProtocolParams;
import cz.msebera.android.httpclient.protocol.HTTP;
import de.dhbwloe.campusapp.CampusAppContext;

/**
 * Created by pk910 on 08.02.2016.
 */
public class SecureLoginManager extends AsyncTask<SecureLoginTask, Void, SecureLoginTask> {
    private static final String SECURELOGIN_URL = "https://securelogin1.dhbw-loerrach.de/cgi-bin/login";
    private static final int SECURELOGIN_TIMEOUT = 20000;
    private static final int SECURELOGIN_HANDSHAKE_TIMEOUT = 10000;
    private static String SECURELOGIN_FAILED_REGEX = "Authentication failed";
    private static String SECURELOGIN_SUCCESS_REGEX = "User Authenticated";

    public interface SecureLoginResult {
        void onSecureLoginFailed(String errMsg);
        void onSecureLoginSuccess();
    }

    private CampusAppContext AppContext;
    private SecureLoginTask task;
    private String responseString;

    @Override
    protected SecureLoginTask doInBackground(SecureLoginTask... params) {
        task = params[0];
        if (AppContext == null)
            AppContext = CampusAppContext.getInstance();

        task.responseReceived = false;
        task.responseString = null;

        //build login post request:
        //https://securelogin1.dhbw-loerrach.de/cgi-bin/login
        // user=***censored***
        // password=***censored***
        // cmd=authenticate
        // Login=Log+In

        /* Dear DHBW Tech Guys
        * Go and replace these fucking outdated and insecure SSL implementation for your "secure"login page!
        * 3DES_EDE_CBC
        *
        * Ok,  after ~3 days android ssl library analysis, i've finnaly made it communicating with an 3DES Endpoint.
        * Dear DHBW Tech Guys, gu fuck yourself! If you don't know why, continue (^.^)
        */

        //SSLSocket socket = null;
        StringBuilder responseString = new StringBuilder();
        try {
            SSLContext sslContext = SSLContext.getInstance("TLS");
            SecureLoginTrustManager loginTrustManager = new SecureLoginTrustManager();
            sslContext.init(null, new TrustManager[]{loginTrustManager}, null);
            SSLSocketFactory innerSslSocketPactory = SSLCertificateSocketFactory.getInsecure(SECURELOGIN_HANDSHAKE_TIMEOUT, new SSLSessionCache(AppContext.getMainActivity()));
            SSLSocketFactory sslSocketFactory = new SecureLoginSocketFactory(sslContext, innerSslSocketPactory);

            //SSLSocket socket = (SSLSocket) sslSocketFactory.createSocket("securelogin1.dhbw-loerrach.de", 443);
            //socket.startHandshake();

            Log.i("SecureLogin", "HTTPS INITIALIZED");

            URL url = new URL(SECURELOGIN_URL);
            URLConnection conn = url.openConnection();

            if (conn instanceof HttpsURLConnection) {
                ((HttpsURLConnection)conn).setSSLSocketFactory(sslSocketFactory);
                ((HttpsURLConnection )conn).setRequestMethod("POST");
                ((HttpsURLConnection)conn).setHostnameVerifier(org.apache.http.conn.ssl.SSLSocketFactory.ALLOW_ALL_HOSTNAME_VERIFIER);
            } else {
                ((HttpURLConnection) conn).setRequestMethod("POST");
            }
            conn.setConnectTimeout(SECURELOGIN_TIMEOUT);
            conn.setReadTimeout(SECURELOGIN_TIMEOUT);

            conn.setDoInput(true);
            conn.setDoOutput(true);

            List<NameValuePair> postData = new ArrayList<NameValuePair>();
            postData.add(new BasicNameValuePair("cmd", "authenticate"));
            postData.add(new BasicNameValuePair("Login", "Log+In"));
            postData.add(new BasicNameValuePair("user", task.settings.username));
            postData.add(new BasicNameValuePair("password", task.settings.password));

            OutputStream os = conn.getOutputStream();
            BufferedWriter writer = new BufferedWriter(
                    new OutputStreamWriter(os, "UTF-8"));
            String postString = encodePostData(postData);
            writer.write(postString);
            writer.flush();
            writer.close();
            os.close();

            conn.connect();

            int responseCode;
            if (conn instanceof HttpsURLConnection)
                responseCode = ((HttpsURLConnection)conn).getResponseCode();
            else
                responseCode = ((HttpURLConnection)conn).getResponseCode();

            if (responseCode == HttpsURLConnection.HTTP_OK) {
                task.responseReceived = true;
                String line;
                BufferedReader br=new BufferedReader(new InputStreamReader(conn.getInputStream()));
                while ((line=br.readLine()) != null) {
                    responseString.append(line);
                }
            } else {
                task.responseError = "HTTP " + Integer.toString(responseCode);
            }

        } catch (Exception e) {
            task.responseError = e.getMessage();
            Log.i("SecureLogin", e.toString() + ":" + e.getMessage());
        }

        task.responseString = responseString.toString();

        return task;
    }

    @Override
    protected void onPreExecute() {
        super.onPreExecute();

    }

    @Override
    protected void onPostExecute(SecureLoginTask task) {
        super.onPostExecute(task);

        boolean success = false;
        String error = null;

        if(task.responseReceived) {
            Pattern p1 = Pattern.compile(SECURELOGIN_SUCCESS_REGEX);
            Pattern p2 = Pattern.compile(SECURELOGIN_FAILED_REGEX);

            Matcher m1 = p1.matcher(task.responseString);
            Matcher m2 = p2.matcher(task.responseString);

            if(m1.find())
                success = true;
            else if(m2.find())
                error = "Incorrect username or password code entered. Please try again.";
            else
                error = "An unknown error occured!";
        } else if(task.responseError != null) {
            error = task.responseError;
        }
        if(success)
            task.loginCallback.onSecureLoginSuccess();
        else
            task.loginCallback.onSecureLoginFailed(error);
    }

    private String encodePostData(List<NameValuePair> params) throws UnsupportedEncodingException {
        StringBuilder result = new StringBuilder();
        boolean first = true;

        for (NameValuePair pair : params) {
            if (first)
                first = false;
            else
                result.append("&");

            result.append(URLEncoder.encode(pair.getName(), "UTF-8"));
            result.append("=");
            result.append(URLEncoder.encode(pair.getValue(), "UTF-8"));
        }

        return result.toString();
    }
}
